Bug 1897434 - Review Request: ghc-haxr - XML-RPC client and server library
Summary: Review Request: ghc-haxr - XML-RPC client and server library
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
medium
unspecified
Target Milestone: ---
Assignee: Tristan Cacqueray
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2020-11-13 04:51 UTC by Jens Petersen
Modified: 2021-02-28 17:38 UTC (History)
2 users (show)

Fixed In Version: ghc-haxr-3000.11.4.1-2.fc34
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2021-01-23 01:30:10 UTC
Type: ---
tdecacqu: fedora-review+


Attachments (Terms of Use)

Description Jens Petersen 2020-11-13 04:51:26 UTC
Spec URL: https://petersen.fedorapeople.org/reviews/ghc-haxr/ghc-haxr.spec
SRPM URL: https://petersen.fedorapeople.org/reviews/ghc-haxr/ghc-haxr-3000.11.4.1-1.fc33.src.rpm

Description:
HaXR is a library for writing XML-RPC client and server applications in
Haskell.


Koji scratch build: https://koji.fedoraproject.org/koji/taskinfo?taskID=55505068

Comment 1 Jens Petersen 2020-12-04 04:42:05 UTC
Needed for the koji library used by fbrnch (also newer pkgtreediff and softwarefactory).

Comment 2 Tristan Cacqueray 2021-01-08 16:47:11 UTC
Notes:
- Doesn't hackage publish gpg signature?
- The project has a test directory but it's not defined in the cabal file,
  so i guess it would be complicated to add the %check section.
- The doc example correctly compiled and ran after package install
- It seems like %{name}-devel.files list has spurious-executable-perm, though
  i'm not sure how the list is created.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "BSD 3-clause "New" or "Revised"
     License". 25 files have unknown license. Detailed output of
     licensecheck in /home/tdecacqu/1897434-ghc-haxr/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package does not own files or directories owned by other packages.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 30720 bytes in 15 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[?]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[ ]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: ghc-haxr-3000.11.4.1-1.fc34.x86_64.rpm
          ghc-haxr-devel-3000.11.4.1-1.fc34.x86_64.rpm
          ghc-haxr-3000.11.4.1-1.fc34.src.rpm
ghc-haxr.x86_64: W: no-documentation
ghc-haxr-devel.x86_64: W: spurious-executable-perm /usr/share/doc/ghc-haxr-devel/examples/Makefile
ghc-haxr-devel.x86_64: W: spurious-executable-perm /usr/share/doc/ghc-haxr-devel/examples/Person.hs
ghc-haxr-devel.x86_64: W: spurious-executable-perm /usr/share/doc/ghc-haxr-devel/examples/PersonTH.hs
ghc-haxr-devel.x86_64: W: spurious-executable-perm /usr/share/doc/ghc-haxr-devel/examples/make-stubs.hs
ghc-haxr-devel.x86_64: W: spurious-executable-perm /usr/share/doc/ghc-haxr-devel/examples/parse_response.hs
ghc-haxr-devel.x86_64: W: spurious-executable-perm /usr/share/doc/ghc-haxr-devel/examples/person_client.hs
ghc-haxr-devel.x86_64: W: spurious-executable-perm /usr/share/doc/ghc-haxr-devel/examples/person_server.hs
ghc-haxr-devel.x86_64: W: spurious-executable-perm /usr/share/doc/ghc-haxr-devel/examples/raw_call.hs
ghc-haxr-devel.x86_64: W: spurious-executable-perm /usr/share/doc/ghc-haxr-devel/examples/simple_client.hs
ghc-haxr-devel.x86_64: W: spurious-executable-perm /usr/share/doc/ghc-haxr-devel/examples/simple_server.hs
ghc-haxr-devel.x86_64: W: spurious-executable-perm /usr/share/doc/ghc-haxr-devel/examples/test_client.hs
ghc-haxr-devel.x86_64: W: spurious-executable-perm /usr/share/doc/ghc-haxr-devel/examples/test_server.hs
ghc-haxr-devel.x86_64: W: spurious-executable-perm /usr/share/doc/ghc-haxr-devel/examples/time-xmlrpc-com.hs
ghc-haxr-devel.x86_64: W: spurious-executable-perm /usr/share/doc/ghc-haxr-devel/examples/validate.hs
3 packages and 0 specfiles checked; 0 errors, 15 warnings.




Rpmlint (installed packages)
----------------------------
warning: Found bdb Packages database while attempting sqlite backend: using bdb backend.
warning: Found bdb Packages database while attempting sqlite backend: using bdb backend.
ghc-haxr.x86_64: W: undefined-non-weak-symbol /usr/lib64/libHShaxr-3000.11.4.1-Eu5eecauzHf7zckkFLlx8r-ghc8.8.4.so stg_gc_unpt_r1

[..] lots of other undefined-non-weak-symbol for stg_

2 packages and 0 specfiles checked; 0 errors, 1877 warnings.



Unversioned so-files
--------------------
ghc-haxr: /usr/lib64/libHShaxr-3000.11.4.1-Eu5eecauzHf7zckkFLlx8r-ghc8.8.4.so

Source checksums
----------------
https://hackage.haskell.org/package/haxr-3000.11.4.1/haxr-3000.11.4.1.tar.gz :
  CHECKSUM(SHA256) this package     : 1ef6ee518720c6f5959169fd7fde7e7641ff71f8c02c20e645a88f221853c389
  CHECKSUM(SHA256) upstream package : 1ef6ee518720c6f5959169fd7fde7e7641ff71f8c02c20e645a88f221853c389


Requires
--------
ghc-haxr (rpmlib, GLIBC filtered):
    libHSHaXml-1.25.5-4iJ6mcsd4da4vQiNb6Hkid-ghc8.8.4.so()(64bit)
    libHSHsOpenSSL-0.11.4.18-6UnNvQ306xc6HmhIhGM8NK-ghc8.8.4.so()(64bit)
    libHSbase-4.13.0.0-ghc8.8.4.so()(64bit)
    libHSbase64-bytestring-1.0.0.3-6nNbupf0oNc9ekFOSwyfJw-ghc8.8.4.so()(64bit)
    libHSbytestring-0.10.10.1-ghc8.8.4.so()(64bit)
    libHSghc-prim-0.5.3-ghc8.8.4.so()(64bit)
    libHShttp-common-0.8.2.1-3UDCLk9s7YA9IOM18m32U8-ghc8.8.4.so()(64bit)
    libHShttp-streams-0.8.7.2-LS7Y4XJpAH5Er25Mn3hRbb-ghc8.8.4.so()(64bit)
    libHSinteger-gmp-1.0.2.0-ghc8.8.4.so()(64bit)
    libHSio-streams-1.5.1.0-EXTh6xu6nYT2S8bgUjIe7K-ghc8.8.4.so()(64bit)
    libHSmtl-2.2.2-ghc8.8.4.so()(64bit)
    libHSnetwork-uri-2.6.3.0-CPjS2hnZr1IIlGhZ1dITqG-ghc8.8.4.so()(64bit)
    libHSold-time-1.1.0.3-75MCuoGSdcPG1Cpmm1miBJ-ghc8.8.4.so()(64bit)
    libHSpolyparse-1.13-4iUooCvGMcnC0mPzTcZKJt-ghc8.8.4.so()(64bit)
    libHSpretty-1.1.3.6-ghc8.8.4.so()(64bit)
    libHStemplate-haskell-2.15.0.0-ghc8.8.4.so()(64bit)
    libHStext-1.2.4.0-ghc8.8.4.so()(64bit)
    libHStime-1.9.3-ghc8.8.4.so()(64bit)
    libHStransformers-0.5.6.2-ghc8.8.4.so()(64bit)
    libHSutf8-string-1.0.1.1-K3Cc2i5eeGM49mkpXdBKoc-ghc8.8.4.so()(64bit)
    libc.so.6()(64bit)
    rtld(GNU_HASH)

ghc-haxr-devel (rpmlib, GLIBC filtered):
    ghc-compiler
    ghc-devel(HaXml-1.25.5-4iJ6mcsd4da4vQiNb6Hkid)
    ghc-devel(HsOpenSSL-0.11.4.18-6UnNvQ306xc6HmhIhGM8NK)
    ghc-devel(array-0.5.4.0)
    ghc-devel(base-4.13.0.0)
    ghc-devel(base-compat-0.11.1-4oueEGUxmwHC6tuHqQ6hE2)
    ghc-devel(base64-bytestring-1.0.0.3-6nNbupf0oNc9ekFOSwyfJw)
    ghc-devel(blaze-builder-0.4.1.0-82SjfGnhHM1L0mrMMN11qB)
    ghc-devel(bytestring-0.10.10.1)
    ghc-devel(http-streams-0.8.7.2-LS7Y4XJpAH5Er25Mn3hRbb)
    ghc-devel(http-types-0.12.3-91k63qdLQk0H6CBqDfaGkl)
    ghc-devel(io-streams-1.5.1.0-EXTh6xu6nYT2S8bgUjIe7K)
    ghc-devel(mtl-2.2.2)
    ghc-devel(network-3.1.1.1-CtLURRWWFvn3QC3vC70cjB)
    ghc-devel(network-uri-2.6.3.0-CPjS2hnZr1IIlGhZ1dITqG)
    ghc-devel(old-locale-1.0.0.7-KOGgqu8HfWChZyQBUEp1c)
    ghc-devel(old-time-1.1.0.3-75MCuoGSdcPG1Cpmm1miBJ)
    ghc-devel(template-haskell-2.15.0.0)
    ghc-devel(text-1.2.4.0)
    ghc-devel(time-1.9.3)
    ghc-devel(utf8-string-1.0.1.1-K3Cc2i5eeGM49mkpXdBKoc)
    ghc-haxr(x86-64)



Provides
--------
ghc-haxr:
    ghc-haxr
    ghc-haxr(x86-64)
    libHShaxr-3000.11.4.1-Eu5eecauzHf7zckkFLlx8r-ghc8.8.4.so()(64bit)

ghc-haxr-devel:
    ghc-devel(haxr-3000.11.4.1-Eu5eecauzHf7zckkFLlx8r)
    ghc-haxr-devel
    ghc-haxr-devel(x86-64)
    ghc-haxr-static
    ghc-haxr-static(x86-64)



Generated by fedora-review 0.7.6 (b083f91) last change: 2020-11-10
Command line :/usr/bin/fedora-review -b 1897434
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, C/C++, Haskell, Shell-api
Disabled plugins: fonts, SugarActivity, Perl, PHP, Ocaml, Java, Python, R
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 3 Jens Petersen 2021-01-09 12:09:30 UTC
Thanks for reviewing the package

(In reply to Tristan Cacqueray from comment #2)
> - Doesn't hackage publish gpg signature?

Not that I know of: it would be a good idea though.

> - The project has a test directory but it's not defined in the cabal file,
>   so i guess it would be complicated to add the %check section.

I only see it in git: not sure if that dir is still managed.

> - The doc example correctly compiled and ran after package install
> - It seems like %{name}-devel.files list has spurious-executable-perm, though
>   i'm not sure how the list is created.

Okay I can fix the examples/ permissions, good catch, thanks
> 3 packages and 0 specfiles checked; 0 errors, 15 warnings.

> ghc-haxr.x86_64: W: undefined-non-weak-symbol
> /usr/lib64/libHShaxr-3000.11.4.1-Eu5eecauzHf7zckkFLlx8r-ghc8.8.4.so
> stg_gc_unpt_r1
> 
> [..] lots of other undefined-non-weak-symbol for stg_

Yeah I hope this gets fixed in ghc some day.

Comment 6 Jens Petersen 2021-01-11 06:38:07 UTC
Thank you for the review, Tristan

https://pagure.io/releng/fedora-scm-requests/issue/31696

Comment 7 Gwyn Ciesla 2021-01-11 14:20:16 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/ghc-haxr

Comment 8 Fedora Update System 2021-01-14 06:13:05 UTC
FEDORA-2021-4b38fc1294 has been submitted as an update to Fedora 33. https://bodhi.fedoraproject.org/updates/FEDORA-2021-4b38fc1294

Comment 9 Fedora Update System 2021-01-15 02:15:14 UTC
FEDORA-2021-4b38fc1294 has been pushed to the Fedora 33 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2021-4b38fc1294 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-4b38fc1294

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 10 Fedora Update System 2021-01-23 01:30:10 UTC
FEDORA-2021-4b38fc1294 has been pushed to the Fedora 33 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 11 Fedora Update System 2021-02-20 17:31:59 UTC
FEDORA-2021-8d71372682 has been submitted as an update to Fedora 32. https://bodhi.fedoraproject.org/updates/FEDORA-2021-8d71372682

Comment 12 Fedora Update System 2021-02-21 01:09:21 UTC
FEDORA-2021-8d71372682 has been pushed to the Fedora 32 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2021-8d71372682 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-8d71372682

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 13 Fedora Update System 2021-02-28 17:38:25 UTC
FEDORA-2021-8d71372682 has been pushed to the Fedora 32 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.